/*******************************************************************************

   MINUTERIA ELETRNICA  DE TEMPO AJUSTVEL

   COM PIC 12F675

   AUTOR: CLAUDIO LARIOS

   DATA: 22/03/2015
   
   TEMPO QUE A MINUTERIA ACIONA AS LAMPADAS APS PULSO PODE SER REGULADO
   NO TRIMPOT DE 100K, ENTRE 1 SEG A 4 MIN E 15 SEG. (1V POR MINUTO, NO CURSOR)

   ESTE ARQUIVO  PARTE INTEGRANTE DO BLOG 'LARIOS.TECNOLOGIA.WS'
   USI DIDTICO APENAS.

   EXTREMO CUIDADO DEVE SER TOMADO AO MANUSEAR CIRCUITOS COM ALTA TENSO


*******************************************************************************/
#include <12F675.h>
#device adc=8
#use delay(clock=4000000)
#fuses NOWDT,INTRC_IO, NOCPD, NOPROTECT, NOMCLR, NOPUT, NOBROWNOUT

#byte  gpio    = 0x05
#byte  trisio  = 0x85

#bit   tris_g   = 0x85.2  //direo
#bit   gpio_g   = 0x05.2  // pino 5  triac gate
#bit   in_z     = 0x05.4  // pino 3 passagem por zero
#bit   sw       = 0x05.5  //pino 2  pulsador

//VARIAVIS GLOBAIS
int1 flagon;
int8 cnt;
int16 tempo,tempo_max;
//CONSTANTES
int8 const freq_rede = 60; //60 hz
int16 const time_vmin = 50000/freq_rede;// tempo minimo para vmin entre mt1:mt2

//------------------------------------------------------------------------------
//  PULSA TRIAC
//------------------------------------------------------------------------------

void pulsa_triac(){//rotina de pulso na gate do triac
  int8 a;
   for(a=0; a<20;a++){
    tris_g=0; //saida em '0'
    delay_us(50);//pulso de 50 useg
    tris_g=1;
    delay_us(50);
   }
}

//------------------------------------------------------------------------------
//  ROTINA PRINCIPAL
//------------------------------------------------------------------------------

void main() {

   setup_adc_ports(sAN1|VSS_VDD);
   setup_adc(ADC_CLOCK_DIV_8);
   set_adc_channel(1);//LIGA CONVERSOR AD NO PINO 6
   setup_counters(RTCC_INTERNAL,RTCC_DIV_1);
   setup_timer_1(T1_DISABLED);
   setup_comparator(NC_NC_NC_NC);
   setup_vref(FALSE);
   gpio= 0x00;
   trisio=0b111111;
   flagon=0;
   cnt=0;
   tempo=0;
   delay_ms(2000);//carga do capacitor da fonte
   
//------------------------------------------------------------------------------
//  LAO PRINCIPAL DE REPETIO
//------------------------------------------------------------------------------

   while(1){

     if((sw)&&(!flagon)){//testa pulsador
       if(++cnt==30){
          flagon=1;
          tempo=0;
          tempo_max=read_adc();
          tempo_max=(tempo_max+1) * freq_rede;
          }
     }
     if(!sw) cnt=0;//zera cnt se pulsador no foi acionado

     if(flagon){ // se pulsador foi acionado
        if(in_z) delay_us(time_vmin); pulsa_triac(); //testa senode e dispara
        while(in_z);//aguarda mudana no ciclo para -
        delay_us(time_vmin); pulsa_triac(); // aguarda e pulsa triac
        while(!in_z);//aguarda mudana no ciclo para +
        if(++tempo==tempo_max) {flagon=0; }//incrementa e compara se fim do tempo
     }

   }//while(1)

}//main()
